#!/usr/bin/env ruby

##
# UPnPwn v0.8.0-bh
# Copyright 2008 Jonathan Squire, CISSP
##

# Some more examples of how to use this toolkit

require 'upnp'
require 'ssdp.rb'

#Send an SSDP discovery
#s = SSDP.new
#s.discover

 
u=UPnPHost.new
#  u.location="http://192.168.55.222:2869/IGatewayDeviceDescDoc" 
u.location="http://192.168.55.222:5678/igd.xml"
u.load_xml_data
u.parse_services
  
target_service='urn:schemas-upnp-org:service:WANIPConnection:1'
  
 #
 # Print service details
 #
   u.service.each {
     |key, value|
     puts value.info
   }

 #
 # Init all services
 #
   u.service.each {
     |key, value|
	 value.load_xml_data
	 value.parse_scpd
     value.soap_init
   }

 #
 # Print service details
 #
   u.service.each {
     |key, value|
     puts value.info
   }
   
 
 
  s=u.service[target_service]

#The below were handled in soap_init, but you could have done them manually:
  
#dynamically add a specific function to the class
#s.instance_eval  s.dynamic_action_code("GetConnectionTypeInfo",false)

#dynamically add all SOAP methods to this instance of the object.
#   s.actions.each {
#   |action|
#   s.instance_eval s.dynamic_action_code(action)
#   }

	puts s.GetConnectionTypeInfo
	puts s.GetExternalIPAddress
	
	host=""
	s.GetGenericPortMappingEntry(0)
	s.AddPortMapping(host,22,"TCP",22,"192.168.55.88",1,"SSH Forward",0)
	s.DeletePortMapping(host,22,"TCP")

	s.AddPortMapping(host,1234,"TCP",1234,"192.168.88.32",1,"UPnPwn",0)
	s.DeletePortMapping(host,1234,"TCP")
	
#Use IRB to further explore the UPnPService class
